<?php
include ('/usr/local/www/berogui/includes/isgwtelnet.php');
include ('/usr/local/www/berogui/misc/database.php');
include "includes/JSON.php";

class PowerDebug
{

    private $server;

    private $http_port = "8888";

    private $ftp_port;

    private $ftp_pwd;

    private $serial;

    private $remPDObj;

    private $json;

    private $options;

    private $localIP;

    private $eph_portrange;

    private $beroAri;

    public $analog_debug_device = "/sys/class/bnxanalog/debugtool";

    public $gsm_debug_device = "/sys/class/bnxgsm/debug";

    public $tecs;

    public $filter;

    private $dump_filter;

    public function PowerDebug($server, $tecs, $filter)
    {
        $this->beroAri = new beroAri();
        $this->json = new Services_JSON();
        $this->tecs = $this->json->decode($tecs);
        $tmp = file_get_contents("/proc/sys/net/ipv4/ip_local_port_range");
        $tmp = explode("\t", $tmp);
        $this->eph_portrange = $port_range = str_replace("\n", "", "$tmp[0]-$tmp[1]");
        $this->filter = $filter;
        $fw_version = file_get_contents("/usr/local/FILENAME");
        $fw_version = explode("-", $fw_version);
        $fw_version = $fw_version[1];
        $this->options = array(
            'http' => array(
                'method' => "GET",
                'header' => "User-Agent: Berofix VOIP Gateway ($fw_version)\r\n",
                'timeout' => 5
            )
        );
        
        $this->localIP = $_SERVER['HTTP_HOST'];
        $res = file_get_contents('/proc/cmdline');
        preg_match("/[^a-zA-Z0-9=]*?d=(?<serial>.+) /", $res, $serial);
        $this->serial = $serial['serial'];
        
        if (strpos($server, ':') !== FALSE) {
            $temp = explode(":", $server);
            $this->server = $temp[0];
            $this->http_port = $temp[1];
        } else {
            $this->server = $server;
        }
    }

    public function init()
    {
        if (file_exists("/tmp/powerdebug.lck"))
            return "PowerDebug is already running";
        if ($this->beroAri->get('trace') === 'yes')
            return $this->json->decode('{"answer":"ERROR","message":"A regular trace is still running, please stop it first."}');
        $http_context = stream_context_create($this->options);
        $response = file_get_contents("http://" . $this->server . ":" . $this->http_port . "/powerdebug?cmd=createtrace&serial=" . $this->serial, false, $http_context);
        if (! $response)
            return $this->json->decode('{"answer":"ERROR","message":"Server doesn\'t response"}');
        $this->remPDObj = $this->json->decode($response);
        $this->ftp_port = $this->remPDObj->ftpPort;
        $this->ftp_pwd = $this->remPDObj->ftpPass;
        $this->dump_filter = $this->buildFilter($this->filter);
        file_put_contents("/tmp/info.html",print_r($this->getInfo(),true));
        return $this->remPDObj;
    }

    public function isProcessRunning()
    {
        exec("ps ax | grep \"ncftpput\" 2>&1", $output);
        if (count($output) > 1)
            return true;
        else
            return false;
    }

    public function getPDObj()
    {
        return $this->remPDObj;
    }

    public function getServer()
    {
        return $this->server;
    }

    public function getStatus()
    {
        $http_context = stream_context_create($this->options);
        $response = file_get_contents("http://" . $this->server . ":" . $this->http_port . "/powerdebug?cmd=status&serial=" . $this->serial, false, $http_context);
        if (! $response)
            return $this->json->decode('{"answer":"ERROR","message":"Server doesn\'t response"}');
        
        $response = $this->json->decode($response);
        return $response;
    }

    public function start()
    {
        $http_context = stream_context_create($this->options);
        $response = file_get_contents("http://" . $this->server . ":" . $this->http_port . "/powerdebug?cmd=start&serial=" . $this->serial, false, $http_context);
        if (! $response)
            return $this->json->decode('{"answer":"ERROR","message":"Server doesn\'t response"}');
        $response = $this->json->decode($response);
        if (strcasecmp($response->answer, "SUCCESS") != 0)
            return "PDServer logs an error has occured. Message: $response->message";
        
        // copy files at start
        $this->copyFiles("before_start");
        // Connect isgw
        $isgw = new isgwtelnet();
        $isgw->isgw_login();
        
        // starte tcpDump
        if ($this->tecs->sip == "true") {
            // eth0
            exec("/usr/local/sbin/tcpdump -s 0 -U -n -C2 -w- -i eth0 $this->dump_filter | /apps/powerdebug/bin/ncftpput -c -u $this->serial -p $this->ftp_pwd -P $this->ftp_port $this->server tcpDump.eth0.pcap > /dev/null &");
            // local loop
            exec("/usr/local/sbin/tcpdump -s 0 -U -C2 -n -w- -i lo $this->dump_filter | /apps/powerdebug/bin/ncftpput -c -u $this->serial -p $this->ftp_pwd -P $this->ftp_port $this->server tcpDump.lo.pcap > /dev/null &");
        }
        
        // starte analogtrace
        if ($this->tecs->analog == "true") {
            exec("/bin/nc -ul 127.0.0.1 -p60501 | /apps/powerdebug/bin/ncftpput -c -u $this->serial -p $this->ftp_pwd -P $this->ftp_port $this->server analog.log > /dev/null &");
            exec("echo 1 > $this->analog_debug_device");
        }
        
        // starte gsmtrace
        if ($this->tecs->gsm == "true") {
            exec("/bin/nc -ul 127.0.0.1 -p60502 | /apps/powerdebug/bin/ncftpput -c -u $this->serial -p $this->ftp_pwd -P $this->ftp_port $this->server gsm.log > /dev/null &");
            exec("echo 1 > $this->gsm_debug_device");
        }
        
        if ($this->tecs->isdn == "true") {
            // starte ISDN-Trace
            $ports = trim($isgw->isgw_isdnstate());
            $ports = explode("* Port ", $ports);
            unset($ports[0]);
            $ports = array_values($ports);
            $i = 0;
            foreach ($ports as $port) {
                $tmp = explode(" ", $port);
                $ports[$i] = $tmp[0];
                $i ++;
            }
            
            if (! empty($ports)) {
                $ports = $ports = implode(",", $ports);
                $cmd = "/usr/bin/env -i /usr/bin/php /apps/powerdebug/bin/misdn_debugtool.php p=$ports s=$this->server:$this->ftp_port u=$this->serial pass=$this->ftp_pwd > /dev/null &";
                // $cmd;
                exec($cmd);
            }
        }
        
        // starte isgw.log
        exec("/bin/nc -ul 127.0.0.1 -p54444 | /apps/powerdebug/bin/ncftpput -c -V -u $this->serial -p $this->ftp_pwd -P $this->ftp_port $this->server isgw.log > /dev/null &");
        usleep(100000);
        $isgw->loglevel(0);
        usleep(100000);
        $isgw->logactive(0);
        usleep(100000);
        $isgw->logserver("127.0.0.1", 54444);
        usleep(100000);
        $isgw->loglevel(9);
        usleep(100000);
        $isgw->logactive(1);
        
        unset($isgw);
        file_put_contents("/tmp/powerdebug.lck", serialize($this));
        
        $this->remPDObj->status = "STARTED";
        
        return;
    }

    private function buildFilter($choice = "all")
    {
        // Lade sip config
        $config = parse_ini_file("/usr/conf/isgw.sip", true);
        
        if ($choice == "siponly" || $choice == "siprtp") {
            // suche local SIP port
            $p = $config['general']['sip_address'];
            $p = explode(":", $p);
            $l_sip = $p[2] == "" ? "5060" : $p[2];
            $f = "port $l_sip";
            
            foreach ($config as $k => $v) {
                if ($k == "general")
                    continue;
                $a = explode(":", $v['address']);
                if (count($a) == 2) {
                    $a = $a[1] == "" ? "5060" : $a[1];
                    if ($a != $l_sip)
                        $f = $f . " or port " . $a;
                }
            }
        }
        
        if ($choice == "siprtp") {
            // suche general rtp ports
            if (array_key_exists('udpports', $config['general'])) {
                $rtp = explode(",", $config['general']['udpports']);
                foreach ($rtp as $v) {
                    if (strpos($v, '-') !== FALSE)
                        $f = $f . " or udp portrange $v";
                    else
                        $f = $f . " or udp port $v";
                }
            }
            if (array_key_exists('rtpports_lan', $config['general'])) {
                $rtp = explode(",", $config['general']['rtpports_lan']);
                foreach ($rtp as $v) {
                    if (strpos($v, '-') !== FALSE)
                        $f = $f . " or udp portrange $v";
                    else
                        $f = $f . " or udp port $v";
                }
            }
            if (array_key_exists('rtpports_wan', $config['general'])) {
                $rtp = explode(",", $config['general']['rtpports_wan']);
                foreach ($rtp as $v) {
                    if (strpos($v, '-') !== FALSE)
                        $f = $f . " or udp portrange $v";
                    else
                        $f = $f . " or udp port $v";
                }
            }
        }
        
        if ($choice == "all") {
            $f = "not dst portrange $this->eph_portrange and not dst port $this->ftp_port and not src portrange $this->eph_portrange";
        }
        
        return $f;
    }

    function copyFiles($targetdir = "")
    {
        $dir = "/tmp";
        $files = scandir($dir);
        $exclude = array(
            "/^\.$/",
            "/^\.\.$/",
            "/^isgw\.log.*$/",
            "/^tcpDump.*$/",
            "/^analog.*$/",
            "/^ISDN.*$/"
        );
        
        foreach ($exclude as $key1 => $pattern) {
            foreach ($files as $key2 => $file) {
                if (preg_match($pattern, $file)) {
                    unset($files[$key2]);
                }
            }
        }
        
        $filesToCopy = implode(" $dir/", $files);
        $filesToCopy = $filesToCopy . " /usr/conf";
        
        exec("/apps/powerdebug/bin/ncftpput -m -u$this->serial -p$this->ftp_pwd -P$this->ftp_port -R  $this->server /$targetdir $filesToCopy");
    }

    public function stop($copy = true)
    {
        if ($copy)
            $this->copyFiles("after_stop");
        
        exec("killall -9 php");
        exec("killall -9 ncftpput");
        exec("killall -9 nc");
        exec("killall -9 tcpdump");
        
        $isgw = new isgwtelnet();
        $isgw->isgw_login();
        usleep(100000);
        $isgw->logactive(0);
        usleep(100000);
        $isgw->loglevel(0);
        usleep(100000);
        $isgw->logserver();
        
        unset($isgw);
        
        if (file_exists($this->analog_debug_device)) {
            exec("echo 0 > $this->analog_debug_device");
        }
        
        if (file_exists($this->gsm_debug_device)) {
            exec("echo 0 > $this->gsm_debug_device");
        }
        
        if (file_exists("/sys/class/mISDN-debugtool/enabled")) {
            exec("echo 0 > /sys/class/mISDN-debugtool/enabled");
            exec("/sbin/rmmod mISDN_debugtool");
        }
        
        if (file_exists("/tmp/powerdebug.lck"))
            unlink("/tmp/powerdebug.lck");
        
        $this->remPDObj->status = "STOPPED";
        
        $http_context = stream_context_create($this->options);
        $response = file_get_contents("http://" . $this->server . ":" . $this->http_port . "/powerdebug?cmd=stop&serial=" . $this->serial, false, $http_context);
        if (! $response)
            return $this->json->decode('{"answer":"ERROR","message":"Server doesn\'t response"}');
        $response = $this->json->decode($response);
        if (strcasecmp($response->answer, "SUCCESS") != 0)
            return "PDServer logs an error has occured. Message: $response->message";
        
        return;
    }

    public function getInfo()
    {
        require_once '/usr/fallback/beroConf.php';
        $bc = new beroConf('root');
        $info = array();
        // Serial
        $res = file_get_contents('/proc/cmdline');
        preg_match("/carduuid=([0-9-]*)/", $res, $serial);
        $info['serial'] = $serial[1];
        // Root FS Version
        $f = @file("/VERSION");
        $tmp = explode("=", $f[1]);
        $info['rootfs'] = $tmp[1];
        
        // FPGA Version
        $info['fpga'] = file_get_contents("/proc/FPGA_VERSION");
        // HW Revision
        $res = file_get_contents('/proc/cmdline');
        preg_match("/.*revision=(?<revision>.*)/", $res, $revision);
        $info['hw_revision'] = $revision['revision'];
        
        // App FS Version
        $info['appfs'] = $bc->get("root", "app-image");
        
        // MAC Address
        exec('/sbin/ifconfig eth0 | /bin/grep HWaddr', $resm);
        preg_match("/[^a-zA-Z0-9:]*? HWaddr (?<mac>.+)/", $resm[0], $mac);
        $info['mac'] = $mac[mac];
        
        // Network Config
        // Netzwerk Konfiguration
        if ($bc->get("root", "vlan-enable") == 1) {
            $info['ip'] = exec('/sbin/ifconfig eth0.' . $bc->get("root", "vlan-id") . ' | sed -ne "s/.*inet addr:\(.*\) Bcast.*/\1/p"');
            $info['mask'] = exec('/sbin/ifconfig eth0.' . $bc->get("root", "vlan-id") . ' | sed -ne "s/.*Mask:\(.*\)/\1/p"');
        } else {
            $info['ip'] = exec('/sbin/ifconfig eth0 | sed -ne "s/.*inet addr:\(.*\) Bcast.*/\1/p"');
            $info['mask'] = exec('/sbin/ifconfig eth0 | sed -ne "s/.*Mask:\(.*\)/\1/p"');
        }
        $info['gateway'] = exec('/sbin/route -n | sed -ne "s/^0\.0\.0\.0[[:blank:]]*\([\.0-9]*\) .*/\1/p"');
        
        $tmp = file('/etc/resolv.conf');
        foreach ($tmp as $line) {
            if (strstr($line, 'nameserver')) {
                $nameserver[] = trim(substr($line, 10));
            }
        }
        unset($tmp);
        $info['dns'] = ((strlen($nameserver[0]) != 0) ? $nameserver[0] : '0.0.0.0');
        $info['secondary_dns'] = ((strlen($nameserver[1]) != 0) ? $nameserver[1] : '0.0.0.0');
        
        // Date and time
        $info['date'] = exec("date  +%d-%B-%Y-%H:%M:%S");
        // Lif
        $lif = array(
            0,
            1
        );
        foreach ($lif as $li) {
            $ba = new beroAri();
            $query = $ba->select('SELECT type FROM isdn WHERE lif="' . $li . '" union SELECT type FROM analog WHERE lif="' . $li . '" union SELECT type FROM gsm WHERE lif="' . $li . '" union SELECT type FROM cas WHERE lif="' . $li . '"');
            $type = sqlite_fetch_single($query);
            if ($type != "")
                $info['lif' . $li] = "li" . $li . ":  " . $type;
        }
        
        $isgw = new isgwtelnet();
        $isgw->isgw_login();
        $isgw_uptime = $isgw->isgw_uptime();
        $isgw_uptime = preg_split("/: /", $isgw_uptime);
        $info['isgw_uptime'] = $isgw_uptime[1];
        // System Uptime
        exec('/usr/bin/uptime', $resup);
        preg_match("/(?<t>.+), load /", $resup[0], $uptime);
        $info['system_uptime'] = $uptime[t];
        $info['sip2sip_license_status'] = $isgw->isgw_siplicensestate();
        $info['sip2sip_number_of_licenses'] = $isgw->isgw_siplicensecount();
        
        // MSP Firmware
        $msp = explode(':', $isgw->Query('fw'));
        $info['msp_fw'] = $msp[1];
        
        return $info;
    }
}

?>